openerp.eiru_image_optimizer = function (instance, local) {
    openerp.eiru_image_optimizer.compressor = new Compress(); 

    if (openerp && openerp.web.form) {
        openerp.web.form.FieldBinary.include({
            on_file_change: function (e) {
                var self = this;

                openerp.eiru_image_optimizer.compressor.compress([e.target.files[0]], { 
                    size: 4,
                    quality: 0.70,
                    maxWidth: 1920,
                    maxHeight: 1920,
                    resize: true
                }).then(function (results) {
                    self.on_file_uploaded(results[0].endSizeInMb * 1024 * 1024, results[0].alt, results[0].ext, results[0].data);
                });
            }
        });
    }
}